// Code generated by gobind. DO NOT EDIT.

// Java class cwtch.Cwtch is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java git.openprivacy.ca/cwtch.im/libcwtch-go
package cwtch;

import go.Seq;

public abstract class Cwtch {
	static {
		Seq.touch(); // for loading the native library
		_init();
	}
	
	private Cwtch() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	
	// skipped const AddContact with unsupported type: cwtch.im/cwtch/event.Type
	
	// skipped const ImportString with unsupported type: cwtch.im/cwtch/event.Field
	
	// skipped const ProfileOnion with unsupported type: cwtch.im/cwtch/event.Field
	
	
	/**
	 * AcceptContact takes in a profileOnion and a handle to either a group or a peer and authorizes the handle
	for further action (e.g. messaging / connecting to the server / joining the group etc.)
	 */
	public static native void acceptContact(String profileOnion, String handle);
	/**
	 * ArchiveConversation sets the conversation to archived
	 */
	public static native void archiveConversation(String profile, String handle);
	public static native void blockContact(String profile, String handle);
	/**
	 * CreateGroup takes in a profile and server in addition to a name and creates a new group.
	 */
	public static native void createGroup(String profile, String server, String name);
	public static native void createProfile(String nick, String pass);
	/**
	 * DeleteContact removes all trace of the contact from the profile
	 */
	public static native void deleteContact(String profile, String handle);
	/**
	 * DeleteProfile deletes a profile given the right password
	 */
	public static native void deleteProfile(String profile, String password);
	/**
	 * GetAppBusEvent blocks until an event
	 */
	public static native String getAppBusEvent();
	public static native String getMessage(String profileOnion, String handle, long message_index);
	public static native String getMessagesByContentHash(String profileOnion, String handle, String contentHash);
	/**
	 * ImportBundle takes in a handle to a profile and an invite string which could have one of many
	different formats (e.g. a peer address, a group invite, a server key bundle, or a combination)
	 */
	public static native void importBundle(String profileOnion, String bundle);
	public static native void loadProfiles(String pass);
	/**
	 * Like StartCwtch, but StartCwtch has already been called so we don&#39;t need to restart Tor etc (probably)
	Do need to re-send initial state tho, eg profiles that are already loaded
	 */
	public static native void reconnectCwtchForeground();
	/**
	 * RejectInvite rejects a group invite
	 */
	public static native void rejectInvite(String profileOnion, String handle);
	public static native void resetTor();
	/**
	 * SendAppEvent is a generic method for Rebroadcasting App Events from a UI
	 */
	public static native void sendAppEvent(String eventJson);
	/**
	 * Send an invitation from `profileOnion` to contact `handle` (peer or group)
	asking them to add the contact `target`  (also peer or group).
	For groups, the profile must already have `target` as a contact.
	 */
	public static native void sendInvitation(String profileOnion, String handle, String target);
	public static native void sendMessage(String profileOnion, String handle, String msg);
	/**
	 * SendProfileEvent is a generic method for Rebroadcasting Profile Events from a UI
	Should generally be used for rapidly prototyping new APIs
	 */
	public static native void sendProfileEvent(String onion, String eventJson);
	/**
	 * SetContactAttribute provides a wrapper around profile.SetProfileAttribute
	 */
	public static native void setContactAttribute(String profileOnion, String contactHandle, String key, String value);
	/**
	 * SetGroupAttribute provides a wrapper around profile.SetGroupAttribute, gated by global experiments...
	 */
	public static native void setGroupAttribute(String profileOnion, String groupHandle, String key, String value);
	/**
	 * SetProfileAttribute provides a wrapper around profile.SetAttribute
	 */
	public static native void setProfileAttribute(String profileOnion, String key, String value);
	/**
	 * ShutdownCwtch is a safe way to shutdown any active cwtch applications and associated ACNs
	 */
	public static native void shutdownCwtch();
	/**
	 * StartCwtch starts cwtch in the library and initlaizes all data structures
		 GetAppbusEvents is always safe to use
	  the rest of functions are unsafe until the CwtchStarted event has been received indicating StartCwtch has completed
	  returns:
	    message: CwtchStarted when start up is complete and app is safe to use
	             CwtchStartError message when start up fails (includes event.Error data field)
	 */
	public static native long startCwtch(String appDir, String torPath);
	/**
	 * UpdateMessageFlags sets the messages flags on a given message for a given profile.
	gomobile doesn&#39;t support uint64...so here we are....
	 */
	public static native void updateMessageFlags(String profileOnion, String handle, long mIdx, long flags);
}
